/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#pragma once

/****************************************************************/
/*																*/
/*			萔`											*/
/*																*/
/****************************************************************/
struct	Macro_Stack {
				string		name;
	unsigned	int			line;
};

/****************************************************************/
/*																*/
/*			NX`											*/
/*																*/
/****************************************************************/
class MMLfile	// :
//	public FileInput
{
//o[ϐ
private:
	vector	<	FileInput*	>		ptcFiles;			//MMLt@C
				FileInput*			nowFile;			//݂̃t@C
	unsigned	int					iFiles;				//݂̃t@CNo.

	map		< string,		string>	ptcMac;				//Macro̕ۑ
	map		< string,		int>	lv_Mac;				//Macro̊Kw

	vector	<	Macro_Stack	>		s_macro;			//lXg̃}NX^bN
				Macro_Stack			nowMacro;
				int					p_macro;			//lXgځH

				bool				f_macro;			//}NIɗtO
				bool				f_2to1;				//}`oCgϊH
public:
	map		<unsigned int,	Patch*>	ptcPatch;			//Patch

				int					offset_Ei;			//
				int					offset_Ev;			//
				int					offset_En;			//
				int					offset_Em;			//
				int					iReleaseVolume;		//
				int					iRepeatMode;		//
				int					iTieMode;			//
				int					timebase;			//
				bool				octave_reverse;		//Octave Reverse
				bool				q_reverse;			//q, Q q_reverse
				int					rest;				// r R}h̋
				int					wait;				// w R}h̋
	unsigned	int					QMax;				// qMax
	unsigned	char				priority;

//o[֐
public:
	MMLfile(const char*	strFileName);
	~MMLfile(void);

				bool	eof(void);				//݂̃t@CEOF`FbN
				bool	eom(void);				//llk̏I`FbN

				void	include();				//|C^ɂt@C#include
	
				void	SetMacro(int i_Lv);
				void	DeleteMacro(int i_Lv);
				void	CallMacro(void);
				int		GetMacroNest(void){return(p_macro);};

				void	SetPatch(void);
				bool	ChkPatch(unsigned int _no);

				int		tellg(void);					//݂̃t@C̃|C^擾
				void	StreamPointerMove(long iSize);	//݂̃t@C̃|C^ړ
				void	Back_one(void);					//1߂
				void	Back(void);						//1߂iSpEpϊΉj

				char	read_char(void);	//1Byteǂݍ
				char	cRead(void);		//1Byteǂݍ݁iSpEpϊΉj
				char	GetChar(void);		//1Byteǂݍ݁iwith EOF & Commend checkj
				string	GetString(void);	//""t  ǂݍ
				int		GetNum(void);		//()t  l  ǂݍ
				int		GetInt(void);		//lǂݍ
				int		GetLength(int DefaultLength);	//ǂݍ݁iZtj
				int		readLength(int DefaultLength);	//ǂݍ

				int		GetCommandID(const Command_Info _command[], unsigned int _size);	//R}hID擾

	unsigned	int		GetLine(void){return(nowFile->GetLine());};
				void	SetLine(unsigned int i){nowFile->SetLine(i);};


	void		Err(const _CHAR msg[]);
	void		Warning(const _CHAR msg[]);
};
