/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "Option.h"


#ifdef _WIN32
// WINDOWŜ݁A'/'ɑΉB
#define OPTCHK (argv[iCount][0]=='/')||(argv[iCount][0]=='-')
#else
// unixnł̓XbV̓fBNg̋؂ɎgׁAs鎖
#define OPTCHK (argv[iCount][0]=='-')
#endif

//==============================================================
//		IvV
//--------------------------------------------------------------
//	
//			int		argc	IvV̐
//			_TCHAR*	argv[]	IvV
//	Ԓl
//			
//	l
//			IvVɃt@Cw肳Ȃꍇ́Awv\ďI
//==============================================================
OPSW::OPSW(int argc, char* argv[]):
	//ݒ
	fHelp(0),		//wv́AftHg͕\ȂB
	saveNSF(false),
	saveASM(false),
	opt(false),
	fErr(false),
	flag_TickCount(true),
	flag_SearchPass(false),
	cDebug(0)
{

	//----------------------------------
	//Local ϐ
	int		iCount;				//whilẽJEgp
	int		iResult;			//ėp

	//Optionp
	int		iOptionChk;			//IvV`FbNp@|C^
	char	cOption;			//IvV`FbNp@
	char	iFlagFilnameExt;	//gq̃tO

	//pX
	string	str_code	= "";
	string	str_dmc		= "";
	string	str_inc		= "";

	//----------------------------------
	//IvV
	iCount=1;	//R}h͔΂
	while(iCount!=argc)
	{
		//--------------
		//IvVXCb`ɃnCt(orXbV)邩mF
		if(OPTCHK){

			//--------------
			//Option Switch	iXbVꍇ̏j
			switch(argv[iCount][1]){
				//--------
				//Help\
				case 'h' :
				case 'H' :
				case '?' :
					fHelp=1;
					break;
				//--------
				//AZu
				case 'o' :
				case 'O' :
					opt = true;
					break;
				//--------
				//AZu
				case 'a' :
				case 'A' :
					saveASM = true;
					break;
				//--------
				//mre
				case 'n' :
				case 'N' :
					saveNSF = true;
					break;
				//--------
				//WG[o͂
				case 'e' :
				case 'E' :
					fErr = true;
					break;
				//--------
				//Tick Count
				case 't' :
				case 'T' :
					flag_TickCount = false;
					break;
				//--------
				//Search Pass
				case 's' :
				case 'S' :
					flag_SearchPass = true;
					break;
				//--------
				//Debug̎w
				case 'D' :
					//0x01:	Class Object Creat
					//0x02:	Address settlement
					//0x04:	Music File Outputing
					//0x40:	Class Object Clear	
					//0x80:	Class Object Delete
					int	i;
					iResult=sscanf(argv[iCount],"-D%d",&i);
					cDebug = (char)i;
					if((iResult==NULL)||(iResult==EOF)){
						opError(_T("-D"));
						break;
					};
					break;
				//--------
				//Debug̎w
				case 'l' :
				case 'L' :
					//Ɏw肳ĂH
					if(strCodeName.empty()){
						iFlagFilnameExt=0;		//gq̗L@Reset
						iOptionChk=0;
						while((cOption=argv[iCount][iOptionChk+2])!=0)
						{
							strCodeName+=cOption;
							if(cOption=='.'){iFlagFilnameExt=1;};
							iOptionChk++;
						};
						if(iFlagFilnameExt==0){
							strCodeName+=".bin";
						};
					} else {
						opError(_T("-l Code t@C2ȏw肳܂B"));
						break;
					};
					break;
				//--------
				//ROMR[ȟpX
				case 'c' :
				case 'C' :
					str_code += &argv[iCount][2];
					str_code.append(1, _PATH_SPLIT);
					break;
				//--------
				//PCM̌pX
				case 'p' :
				case 'P' :
					str_dmc += &argv[iCount][2];
					str_dmc.append(1, _PATH_SPLIT);
					break;
				//--------
				//CN[ht@ČpX
				case 'i' :
				case 'I' :
					str_inc += &argv[iCount][2];
					str_inc.append(1, _PATH_SPLIT);
					break;
				//--------
				//t@C̎w
				case 'f' :
				case 'F' :
					//ɁAt@CĂ邩`FbNB
					if(argv[iCount][3]==0){
						opError(_T("/F t@CĂ܂B"));
						break;
					};
					switch(argv[iCount][2]){
					//--------
					//MMLt@C̎w
					case 'A' :
					case 'a' :
						//Ɏw肳ĂH
						if(strASMname.empty()){
							iFlagFilnameExt=0;		//gq̗L@Reset
							iOptionChk=0;
							while((cOption=argv[iCount][iOptionChk+3])!=0)
							{
								strASMname+=cOption;
								if(cOption=='.'){iFlagFilnameExt=1;};
								iOptionChk++;
							};
							if(iFlagFilnameExt==0){
								strASMname+=".s";
							};
						} else {
							opError(_T("-fa ASM t@C2ȏw肳܂B"));
							break;
						};
						break;
					case 'N' :
					case 'n' :
						//Ɏw肳ĂH
						if(strNSFname.empty()){
							iFlagFilnameExt=0;		//gq̗L@Reset
							iOptionChk=0;
							while((cOption=argv[iCount][iOptionChk+3])!=0)
							{
								strNSFname+=cOption;
								if(cOption=='.'){iFlagFilnameExt=1;};
								iOptionChk++;
							};
							if(iFlagFilnameExt==0){
								strNSFname+=".nsf";
							};
						} else {
							opError(_T("-fn NSF t@C2ȏw肳܂B"));
							break;
						};
						break;
					default :
						opError(_T("-f"));
						break;
					};
				break;
				//--------
				//ftHg
				default :
					opError(_T(""));
					break;
			};

		} else{

			//--------------
			//t@C	iXbVꍇ̏j
			//Ɏw肳ĂH
			if(strMMLname.empty()){
				iFlagFilnameExt=0;		//gq̗L@Reset
				iOptionChk=0;		
				while((cOption=argv[iCount][iOptionChk])!=0)
				{
					strMMLname+=cOption;
					if(cOption=='.'){iFlagFilnameExt=1;};
					iOptionChk++;
				};
				if(iFlagFilnameExt==0){
					strMMLname+=".mml";
				};
			} else {
				opError(_T("MMLt@C2ȏw肳܂B"));
				break;
			};

		};

		//--------------
		//̃IvV
		iCount++;
	};

	//----------------------------------
	//IvVŎw肳ꂽB

	//--------------
	//wv\
	//t@CȂꍇAwv\B
	if((fHelp==1)||(strMMLname.empty())){print_help();};

	if(strASMname.empty()){
		iOptionChk=0;		
		while((cOption=strMMLname[iOptionChk])!='.')
		{
			strASMname+=cOption;
			iOptionChk++;
		};
		strASMname+=".s";
	};

	if(strNSFname.empty()){
		iOptionChk=0;		
		while((cOption=strMMLname[iOptionChk])!='.')
		{
			strNSFname+=cOption;
			iOptionChk++;
		};
		strNSFname+=".nsf";
	};

	//----------------------------------
	//pX̐ݒ

	//MML̃fBNg擾
	iCount	= 0;
	iResult	= 0;
	while(iCount < strMMLname.size()){
		if((strMMLname[iCount] == '\\') || (strMMLname[iCount] == '/')){
			iResult = iCount;
		}
		iCount++;
	}

	//D揇ʂP@JgpX
	//D揇ʂQ@MMLt@C݂pX
	if(iResult > 0){
		string	str_mmldir = "";
		iCount	= 0;
		while(iCount < iResult){
			str_mmldir += strMMLname[iCount];
			iCount++;
		}
		m_pass_code.add(&str_mmldir);
		m_pass_dmc.add(&str_mmldir);
		m_pass_inc.add(&str_mmldir);
	}

	//D揇ʂR@ϐŎw̃pX
	m_pass_code.add(getenv("PATH"));
	m_pass_dmc.add(getenv("DMC_INCLUDE"));

	//D揇ʂS@IvVŎw̃pX
	m_pass_code.add(&str_code);
	m_pass_dmc.add(&str_dmc);
	m_pass_inc.add(&str_inc);



	//----------------------------------
	//

	//	to do	̑̃IvVǉƂ́A̕ӂɒǋLB

	//----------
	//Debugp \
//	cout << "MML = " << strMMLname << endl;
//	cout << "NSF = " << strNSFname << endl;
//	cout << "BIN = " << strBINname << endl;
//	cout << "ASM = " << strASMname << endl;
//	cout << "C   = " << strCname << endl;

/*
	cout << "code:" << endl;
	m_pass_code.debug();

	cout << "dmc:" << endl;
	m_pass_dmc.debug();

	cout << "inc:" << endl;
	m_pass_inc.debug();
*/

};
//==============================================================
//		wvbZ[W
//--------------------------------------------------------------
//	
//			Ȃ
//	Ԓl
//			
//==============================================================
void	OPSW::print_help(){

	_COUT	<<	_T("MML Compiler for NES Sound Driver & Library\n")
				_T("\n")
				_T("  Usage : nsc [ -options ] [file(.mml)]\n")
				_T("\n")
				_T("  -A			Compile to assembly langage.\n")
				_T("  -N			Compile to NSF music format.\n")
				_T("  -E			Error/Warning messages out the stadard error.\n")
				_T("  -T			Disable tick counting.\n")
				_T("  -S			Enable outout the search pass result.\n")
				_T("  -L[file(.bin)]	Filename of the rom code for NSF.\n")
				_T("  -FA[file(.s  )]	Filename of the output assembly langage file.\n")
				_T("  -FN[file(.nsf)]	Filename of the output NSF music format.\n")
				_T("  -C[dir]		Search pass of the rom code for NSF.\n")
				_T("  -P[dir]		Search pass of the delta-pcm.\n")
				_T("  -I[dir]		Search pass of the include file.\n")
				_T("  -H			Print the this help.")	<<	endl;

	nsc_exit(EXIT_SUCCESS);

};
//==============================================================
//		fXgNg
//--------------------------------------------------------------
//	
//			Ȃ
//	Ԓl
//			
//==============================================================
OPSW::~OPSW(){


};
//==============================================================
//		G[	ivZXIj
//--------------------------------------------------------------
//	
//			const	_CHAR	*stErrMsg	G[bZ[W
//	Ԓl
//			
//==============================================================
void OPSW::opError(const _CHAR *stErrMsg){

	if(fErr == true){
		_CERR << _T("IvVsłBF") << stErrMsg << endl;
	} else {
		_COUT << _T("IvVsłBF") << stErrMsg << endl;
	}
	nsc_exit(EXIT_FAILURE);

};
