/*******************************************************************************

			NES Sound Driver & Library	(NSD.lib)	MML Compiler

	Copyright (c) 2012 A.Watanabe (S.W.), All rights reserved.
	 For conditions of distribution and use, see copyright notice in "nsc.cpp".

*******************************************************************************/

#include "StdAfx.h"
#include "DPCM.h"

/****************************************************************/
/*					O[oϐiNXǁEEEj		*/
/****************************************************************/
extern	OPSW*			cOptionSW;	//IvVւ̃|C^ϐ

//==============================================================
//		RXgN^
//--------------------------------------------------------------
//	
//		FileInput*			DPCMfile	PCMi*.dmcj̃t@C
//		unsigned	int		_id			ԍ
//		const		_CHAR	_strName[]	̃IuWFNg̖O
//	Ԓl
//					
//==============================================================
DPCM::DPCM(MMLfile* MML, const char* dmcfile, unsigned int _id, const _CHAR _strName[]):
	MusicItem(_strName),
	f_Use(false),
	m_id(_id)
{
	//----------------------
	//Localϐ
	unsigned	int		_size;
	unsigned	int		i = 0;

	fileopen(dmcfile, &cOptionSW->m_pass_dmc);
	_size = GetSize();
	if(_size > 4081){
		MML->Err(_T("PCM4081ByteȉɂĂB"));
	}

	if((_size & 0x000F) != 0x01){
		iSize = (_size & 0x0FF0) + 0x0011;
	} else {
		iSize = _size;
	}
	_DPCM_size = (char)(iSize >> 4);

	code.resize(iSize);

	//PCM̂]
	while(i < _size){
		code[i] = cRead();
		i++;
	}
	//Padding
	while(i < iSize){
		code[i] = (unsigned char)0xAA;
		i++;
	}

	close();
}

//==============================================================
//		fXgN^
//--------------------------------------------------------------
//	
//				
//	Ԓl
//				
//==============================================================
DPCM::~DPCM(void)
{
}
//==============================================================
//		R[h̎擾
//--------------------------------------------------------------
//	
//		MusicFile*	MUS		R[ho͂ȃf[^t@CEIuWFNg
//	Ԓl
//				
//==============================================================
void	DPCM::getAsm(MusicFile* MUS)
{
	*MUS << ".align	$40\n" << MUS->Header.Label.c_str() << "DPCM" << m_id << ":" << endl;
	MusicItem::getAsm(MUS);
}
